#! /bin/awk -f
# ######################################################################### #
#                                                                           #
# File:     Num2Text.awk                                                    #
# Authors:  Brigitte Bigi                                                   #
# Date:     november, 2003                                                  #
# Licence:  GPL                                                             #
# Brief:    Take numbers of a corpus and returns the corresponding string   #
#                                                                           #
# ######################################################################### #




# ######################################################################### #
#                                                                           #
# Function: unite                                                           #
# 	Converts numbers from 1 to 9 and returns the corresponding string   #
#                                                                           #
# Needed functions: none                                                    #
#                                                                           #
# ######################################################################### #
function unite(number)
{
	if (number == 9)  return "neuf"
	if (number == 8)  return "huit"
	if (number == 7)  return "sept"
	if (number == 6)  return "six"
	if (number == 5)  return "cinq"
	if (number == 4)  return "quatre"
	if (number == 3)  return "trois"
	if (number == 2)  return "deux"
	if (number == 1)  return "un"
	if (number == 0)
	{
		str = "zro"
		for(i=1;i<length(number);i++)
			str = str delimiteur "zro" 
		return str
	}
	return ""
}


# ######################################################################### #
#                                                                           #
# Function: dizaine                                                         #
# 	Converts numbers from 1 to 99 and returns the corresponding string  #
#                                                                           #
# Needed functions: unite                                                   #
#                                                                           #
# ######################################################################### #
function dizaine(number)
{
	if (number >= 90 && number <= 99)
	{
		str = "quatre-vingt" delimiteur dizaine(number - 80)
	}
	else if (number >= 80 && number <= 89)
	{
		str = "quatre-vingt"
		if (number > 80)
			str = str delimiteur unite(number - 80)
	}
	else if (number >= 70 && number <= 79)
	{
		str = "soixante" delimiteur dizaine(number - 60)
	}
	else if (number >= 60 && number <= 69)
	{
		str = "soixante";
		if (number == 61)
			str = str delimiteur "et" delimiteur "un"
		if (number > 61)
			str = str delimiteur unite(number - 60)
	}
	else if (number >= 50 && number <= 59)
	{
		str = "cinquante"
		if (number == 51)
			str = str delimiteur "et" delimiteur "un"
		if (number > 51)
			str = str delimiteur unite(number - 50)
	}
	else if (number >= 40 && number <= 49)
	{
		str = "quarante"
		if (number == 41)
			str = str delimiteur "et" delimiteur "un"
		if (number > 41)
			str = str delimiteur unite(number - 40)
	}
	else if (number >= 30 && number <= 39)
	{
		str = "trente"
		if (number == 31)
			str = str delimiteur "et" delimiteur "un"
		if (number > 31)
			str = str delimiteur unite(number - 30)
	}
	else if (number >= 20 && number <= 29)
	{
		str = "vingt"
		if (number == 21)
			str = str delimiteur "et" delimiteur "un"
		else
			str = str delimiteur unite(number - 20)

	}
	else if (number >= 10 && number <= 19)
	{
		if (number == 10) return "dix"
		if (number == 11) return "onze"
		if (number == 12) return "douze"
		if (number == 13) return "treize"
		if (number == 14) return "quatorze"
		if (number == 15) return "quinze"
		if (number == 16) return "seize "
		if (number == 17) return "dix-sept"
		if (number == 18) return "dix-huit"
		if (number == 19) return "dix-neuf"

	}
	else
		str = unite(number)

	return str
}	


# ######################################################################### #
#                                                                           #
# Function: centaine                                                        #
# 	Converts numbers from 1 to 999 and returns the corresponding string #
#                                                                           #
# Needed functions: dizaine                                                 #
#                                                                           #
# ######################################################################### #
function centaine(number)
{
	if (number >= 100)
	{
		if (number >= 900 && number <= 999)
		{
			str = "neuf" delimiteur "cent"
			if (number > 900)
				str = str "s" delimiteur dizaine(number - 900)
		}
		else if (number >= 800 && number <= 899)
		{
			str = "huit" delimiteur "cent"
			if (number > 800)
				str = str "s" delimiteur dizaine(number - 800)
		}
		else if (number >= 700 && number <= 799)
		{
			str = "sept" delimiteur "cent"
			if (number > 700)
				str = str "s" delimiteur dizaine(number - 700)
		}
		else if (number >= 600 && number <= 699)
		{
			str = "six" delimiteur "cent"
			if (number > 600)
				str = str "s" delimiteur dizaine(number - 600)
		}
		else if (number >= 500 && number <= 599)
		{
			str = "cinq" delimiteur "cent"
			if (number > 500)
				str = str "s" delimiteur dizaine(number - 500)
		}
		else if (number >= 400 && number <= 499)
		{
			str = "quatre" delimiteur "cent"
			if (number > 400)
				str = str "s" delimiteur dizaine(number - 400)
		}
		else if (number >= 300 && number <= 399)
		{
			str = "trois" delimiteur "cent"
			if (number > 300)
				str = str "s" delimiteur dizaine(number - 300)
		}
		else if (number >= 200 && number <= 299)
		{
			str = "deux" delimiteur "cent"
			if (number > 200)
				str = str "s" delimiteur dizaine(number - 200)
		}
		else if (number >= 100 && number <= 199)
		{
			str = "cent"
			if (number > 100)
				str = str delimiteur dizaine(number - 100)
		}
	}
	else
		str = dizaine(number)
		
	return str	
}	


# ######################################################################### #
#                                                                           #
# Function: millier                                                         #
# Converts numbers from 1000 to 99999 and returns the corresponding string  #
#                                                                           #
# Needed functions: unite, dizaine, centaine                                #
#                                                                           #
# ######################################################################### #
function millier(number)
{
	if (number < 1000) str = centaine(number)


	# Milliers
	# --------
	if ( number == 1000 )
		str = "mille"
	
	if ( ( number > 1000 )  &&  ( number < 2000 ) )
		str = "mille" delimiteur centaine(number%1000)

	if ( ( number >= 2000 ) && ( number < 10000 ) )
	{
		if ( (number%1000) != 0 )
			str = unite(int (number/1000)) delimiteur "mille" delimiteur centaine(number%1000)
		else
			str = unite(int (number/1000)) delimiteur "mille"
	}


	# Dizaines de milliers
	# --------------------
	if (number == 10000)
		str = "dix mille"
	
	if (number > 10000 && number < 100000)
	{
		if ( (number%1000) != 0 )
			str = dizaine(int (number/1000)) delimiteur "mille" delimiteur centaine(number%1000)
		else
			str = dizaine(int (number/1000)) delimiteur "mille"
	}
	

	# Centaines de milliers
	# ---------------------
	if (number == 100000)
		str = "cent mille"
	
	if (number >= 100000 && number < 1000000)
	{
		if ( (number%1000) != 0 )
			str = centaine(int (number/1000)) delimiteur "mille" delimiteur centaine(int (number%1000))
		else
			str = centaine(int (number/1000)) delimiteur "mille"
	}

	return str
}


# ######################################################################### #
#                                                                           #
# Function: num2text                                                        #
#	Converts all numbers and returns the corresponding string           #
#                                                                           #
# Needed functions: unite, dizaine, centaine, millier                       #
#                                                                           #
# ######################################################################### #
function num2text(number)
{
	if (number < 1000000)
		str = millier(number)

	# Millions
	# --------
	if (number >= 1000000 && number < 2000000)
		str = "un" delimiteur "million" delimiteur millier(int (number%1000000))

	if (number >= 2000000 && number < 10000000)
		str = unite(int (number/1000000)) delimiteur "millions" delimiteur millier(int (number%1000000))


	# Dizaines de millions
	# --------------------
	if (number == 10000000)
		str = "dix millions"

	if (number > 10000000 && number < 100000000)
		str = dizaine(int (number/1000000)) delimiteur "millions" delimiteur millier(int (number%1000000))
		

	# Centaines de millions
	# ---------------------
	if (number == 100000000)
		str = "cent millions"

	if (number > 100000000 && number < 1000000000)
		str = centaine(int (number/1000000)) delimiteur "millions" delimiteur millier(int (number%1000000))

	if (number > 1000000000)
		return number

	return str
}




# ######################################################################### #
#                                                                           #
# Main Program                                                              #
#                                                                           #
# ######################################################################### #
BEGIN{
	delimiteur = "\n"

}
{
	if ( match($0, /<[\/A-Zsp:]+>/))
        {
                # Les lignes qui sont des balises doivent rester telles-quelles
                print
        }
        else
        {
		# Si la chaine est un nombre on appelle num2text
		# sinon, on crit tel quel
		nombre = $0
		sub(/[0-9]*/, "", nombre)
		if (length(nombre) == 0)
			print num2text($0)		
		else
			print
	}
}

