#! /bin/awk -f
# ######################################################################### #
#                                                                           #
# File:     Text2wfreq.awk                                                  #
# Authors:  Brigitte Bigi                                                   #
# Date:     november, 2003                                                  #
# Licence:  GPL                                                             #
# Brief:    Print list of word frequencies                                  #
#                                                                           #
# ######################################################################### #


{
	# Create a tab word/freq
	for (i = 1; i <= NF; i++)
		freq[$i]++
}

END{

	# sort tab and print on stdout
	sort = "sort +1 -nr"
	for (word in freq)
		printf "%s\t%d\n", word, freq[word] | sort
	close(sort)
}
