#!/bin/sh -x
#
# Test sgmcopy program
#
# $Author: ggravier $
# $Date: 2003/08/22 14:15:12 $
# $Revision: 1.3 $
#


prog=sgmcopy

echo "checking ${prog}:"

if test ! -x ../src/${prog}; then
  echo "  you should probably build ${prog} before running test..."
  exit 1
fi

mkdir -p log

#
# check usage 
#
../src/${prog} --help > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/${prog}.usage > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  usage test passed"
else
  echo "  usage test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check export 
#
../src/${prog} -x ref/init.1 > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/copy.1 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  export test passed"
else
  echo "  export test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check import 
#
gawk '{if (NF == 4) printf "%d %f\n", $1, $2; else print $0}' ref/copy.1 > log/${prog}.input 2> /dev/null
../src/${prog} -i -x log/${prog}.input > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/copy.1 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  import test passed"
else
  echo "  import test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

rmdir log