#!/bin/sh -x
#
# Test ssad program
#
# $Author: ggravier $
# $Date: 2003/08/22 14:15:12 $
# $Revision: 1.3 $
#


prog=ssad

echo "checking ${prog}:"

if test ! -x ../src/${prog}; then
  echo "  you should probably build ${prog} before running test..."
  exit 1
fi

mkdir -p log

#
# check usage 
#
../src/${prog} --help > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/${prog}.usage > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  usage test passed"
else
  echo "  usage test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check silence detection
#
../src/${prog} -f 16000 -m 0.5 dat/know.lin - > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/sad.1 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  silence detection test passed"
else
  echo "  silence detection test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check speech detection
#
../src/${prog} -f 16000 -m 0.5 -r dat/know.lin - > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/sad.2 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  speech detection test passed"
else
  echo "  speech detection test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check silence/speech segmentation
#
../src/${prog} -f 16000 -m 0.5 -a dat/know.lin - > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/sad.3 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  silence/speech segmentation test passed"
else
  echo "  silence/speech segmentation test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

rmdir log
